﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=8.31
@EndOfDesignText@
Sub Class_Globals
	Public pnl As B4XView
	Private xui As XUI
	Public BB1 As BBLabel
	Private te As BCTextEngine
	Public DefaultTextColor As Int = 0xFF3E3E3E
	Private pnlBackground As B4XView
	Private mParent As B4XView
	Private ArrowSize As Int = 40dip
	Private cvs As B4XCanvas
	Public BackgroundColor As Int = xui.Color_White
End Sub

Public Sub Initialize (Parent As B4XView, MaxWidth As Int)
	mParent = Parent
	pnl = xui.CreatePanel("")
	pnl.SetLayoutAnimated(0, 0, 0, MaxWidth, 300dip)
	pnl.LoadLayout("BCToolTip")
	cvs.Initialize(pnlBackground)
	pnl.Color = xui.Color_Transparent
	te.Initialize(pnl)
	BB1.DisableResizeEvent = True
	BB1.ParseData.DefaultColor = DefaultTextColor
	BB1.Padding.Initialize(0, 0, 0, 0)
#if B4A
	Dim p As Panel = pnl
	p.Elevation = 5dip
#End If
End Sub

Public Sub Show (X As Int, Y As Int, Side As String, Message As String)
	BB1.Text = Message
	If pnl.Parent.IsInitialized Then pnl.RemoveViewFromParent
	mParent.AddView(pnl, 100dip, 100dip, pnl.Width, pnl.Height)
	Dim iv As B4XView = BB1.ForegroundImageView
	pnlBackground.SetLayoutAnimated(0, BB1.mBase.Left + iv.Left - ArrowSize, BB1.mBase.Top + iv.Top - ArrowSize, iv.Width + 2 * ArrowSize, iv.Height + 2 * ArrowSize)
	cvs.Resize(pnlBackground.Width, pnlBackground.Height)
	cvs.ClearRect(cvs.TargetRect)
	Dim r As B4XRect
	r.Initialize(0, 0, cvs.TargetRect.Right, cvs.TargetRect.Bottom)
	cvs.DrawRect(r, BackgroundColor, True, 0)
	cvs.Invalidate
End Sub

Sub pnlBackground_Touch (Action As Int, X As Float, Y As Float)
	Log("touch")
End Sub